/*
モータを3つに変更
2014/12/12 五十嵐
*/

#include <linux/errno.h>
#include <sys/io.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <stdio.h>

#include "device.h"
#include "motor.h"
#include "math.h"
#include "./../hardware.h"


//static float Du = 1.0; 

//void motor_drive(float u_l, float u_r ){
void motor_drive(int u_l, int u_r ,int u_b){

	int output_duty_r, output_duty_l , output_duty_b;        //Duty比にしたもの
	int final_output_r, final_output_l, final_output_b;      //最終的に書きこむ値

	int ret_val;
        unsigned char m_data[3];

	int fd_motor;
	fd_motor=device_motor_get();//デバイスの受け渡し

        //output_duty_r = u_r/Du;
        //output_duty_l = u_l/Du;
        output_duty_r = u_r;
        output_duty_l = TIRE_DIRECTION * u_l;
        output_duty_b = TIRE_DIRECTION * u_b;
//        output_duty_b = TIRE_DIRECTION * u_b;
        //printf("duty_r=%d  dutry_l=%d\n", output_duty_r, output_duty_l);

        //PWM不感帯を補正する
        if(output_duty_r > 0){
                output_duty_r = output_duty_r + R_SHIFT_B;
        }else if(output_duty_r < 0){
                output_duty_r = output_duty_r - R_SHIFT_F;
        }else{output_duty_r=0;}

        if(output_duty_l > 0){
                output_duty_l = output_duty_l + L_SHIFT_F;
        }else if(output_duty_l < 0){
                output_duty_l = output_duty_l - L_SHIFT_B;
        }else{output_duty_l=0;}

        if(output_duty_b > 0){
                output_duty_b = output_duty_b + B_SHIFT_F;
        }else if(output_duty_b < 0){
                output_duty_b = output_duty_b - B_SHIFT_B;
        }else{output_duty_b=0;}

        //入力飽和
        output_duty_r = (output_duty_r > 127) ? 127 : output_duty_r;
        output_duty_r = (output_duty_r < -127) ? -127 : output_duty_r;
        output_duty_l = (output_duty_l > 127) ? 127 : output_duty_l;
        output_duty_l = (output_duty_l < -127) ? -127 : output_duty_l;
        output_duty_b = (output_duty_b > 127) ? 127 : output_duty_b;
        output_duty_b = (output_duty_b < -127) ? -127 : output_duty_b;
		//モーター入力用に書き換え
        float right_vdata, left_vdata,back_vdata;
        right_vdata = fabs(output_duty_r) ;
        final_output_r = (output_duty_r < 0) ? right_vdata + 128 : right_vdata;
        left_vdata = fabs(output_duty_l) ;
        final_output_l = (output_duty_l < 0) ? left_vdata + 128 : left_vdata;
        back_vdata = fabs(output_duty_b) ;
        final_output_b = (output_duty_b < 0) ? back_vdata + 128 : back_vdata;
/*moto
        m_data[0]=final_output_l;
        m_data[1]=final_output_r;
        m_data[2]=final_output_b;
*/
//rerwite
        m_data[0]=final_output_b;
        m_data[1]=final_output_l;
        m_data[2]=final_output_r;
        ret_val=write(fd_motor,m_data,3);//書き込み

}

