// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "./../hardware.h"
#include "motor.h"

static pthread_t tasks[1];
static int pwm_duty_r, pwm_duty_l ,pwm_duty_b;

//static int m_data[2];
unsigned char m_data[3];
static int fd_motor;

static void *thread_code(void *t){

	FILE *fp;
	int counter=0;
	int ret_val;

	fp=fopen("test.data","w");
	fd_motor=device_motor_get();

	while(1){
		counter++;

		//if(counter > 200) break;

		m_data[0] = pwm_duty_l;
		m_data[1] = pwm_duty_r;
		m_data[2] = pwm_duty_b;
		printf("%5d left_duty=%5d  right_duty=%5d back_duty=%5d\n",counter,m_data[0],m_data[1],m_data[2]);

		//ret_val=write(fd_motor,m_data,3);
		motor_drive(pwm_duty_l, pwm_duty_r,pwm_duty_b);

		usleep((T_TEST-1)*1000);
		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価

	}

	pwm_duty_l = 0;
	pwm_duty_r = 0;
	pwm_duty_b = 0;

	motor_drive(pwm_duty_l, pwm_duty_r,pwm_duty_b);

	fclose(fp);

	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_motor(){

	int s_val;
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [reight]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [back]= ");
	s_val=scanf("%d",&pwm_duty_b);

	thread_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


