/*************************************
エッジ検出、直線検出をして、壁の傾きからMIRSがどっちの方向を向いているかを判断する。
超音波センサのI/Oエラー用に
　　main関数になっているのを適当な関数になおしてから使う

参考：http://opencv.jp/opencv-2.2/c/imgproc_feature_detection.html

2014/12/24 by K.Mano
****************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include <ctype.h>
//#include "header/extern.h"
#include "header/col_define.h"



int main(){
	int count =1;
	int type;
	IplImage *input;
	IplImage *edges;
	IplImage *color_dst;
	IplImage *color;
	IplImage *gaus;
	IplImage *frame = 0;
	printf("cannyテストスタート！\n");

	//float* line;
	float rho,theta;


	CvSeq* lines = 0;
	double a,b,x0,y0;

	int i;

	CvMemStorage* storage = cvCreateMemStorage(0);

		printf("数字を入力。0なら前方カメラ、0意外なら後方カメラ\n");
		scanf("%d",&type);
		get_img(input, IMG_X, IMG_Y,type);
		input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_GRAYSCALE);
		cvSaveImage("./img_canny/input.jpg", input, NULL);
		printf("aaaaaaa\n");
		gaus = cvCreateImage( cvGetSize(input), 8, 1 );


		//2tika
		cvThreshold(input,gaus,30,255,CV_THRESH_BINARY);


		color_smooth(gaus,gaus,1);
		printf("yoyoyoi\n");
		usleep(1*500*1000);
		gaus = cvLoadImage("./img/gaus.jpg", CV_LOAD_IMAGE_GRAYSCALE);
		printf("ueeeee\n");
		printf("ooooo\n");
		cvSaveImage("./img_canny/gaus.jpg", gaus, NULL);
		usleep(1*1000*1000); //一秒待つ
		edges = cvCreateImage( cvGetSize(input), 8, 1 );
		printf("aaiiio\n");
//		input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_GRAYSCALE);

		//エッジ検出
		cvCanny(gaus, edges, 100, 10, 3);
		
		printf("iiiiiiiii\n");

		cvSaveImage("./img_canny/edges.jpg", edges, NULL);

/***********************************************************************/

		color_dst = cvCreateImage( cvGetSize(edges), 8, 3 );
		color = cvCreateImage( cvGetSize(edges), 8, 3 );
		color = cvLoadImage("./img_canny/edges.jpg", CV_LOAD_IMAGE_COLOR);

		//直線検出
        lines = cvHoughLines2( edges,
                               storage,
                               CV_HOUGH_PROBABILISTIC,
                               1,
                               CV_PI/180,
                               100,
                               200,
                               100 );

	printf("line = %d\n",lines->total);
	int abslength[lines->total];
	int maxabs_num = 0;
	int maxabs = 0;
	float proportional = 1;
        for( i = 0; i < lines->total; i++ )
        {
            CvPoint* line = (CvPoint*)cvGetSeqElem(lines,i);
            cvLine( color_dst, line[0], line[1], CV_RGB(255,0,0), 1, 8,0 );
		//線の大きさ
	    abslength[i] = sqrt((line[0].x-line[1].x)*(line[0].x-line[1].x) + (line[0].y-line[1].y)*(line[0].y-line[1].y));
		//一番大きい線をとる
	    if(maxabs < abslength[i]){ maxabs = abslength[i]; maxabs_num = i;}
        }

	//一番大きい線を壁として検出
	printf("maxabs=%d\n",maxabs_num);
	if(maxabs_num == 0){
		printf("no lines!!\n");
		goto finish;
	}
            CvPoint* line = (CvPoint*)cvGetSeqElem(lines,maxabs_num);
            cvLine( color, line[0], line[1], CV_RGB(255,0,0), 1, 8,0 );
	cvSaveImage("./img_canny/dst.jpg", color_dst, NULL);
	cvSaveImage("./img_canny/color.jpg", color, NULL);

	printf("y = %d,x = %d\n",line[0].y-line[1].y,line[0].x-line[1].x);

	//線の傾き
	proportional = (float)(line[0].y-line[1].y)/(line[0].x-line[1].x);

		if(proportional<0) printf("turn left\n");
		if(proportional>0) printf("turn right\n");
		if(proportional == 0) printf("turn front\n");

		//printf("メイン一周終了\n");
		//usleep(1*1000*1000); //一秒待つ

	finish:	

	

	printf("メインwhileの終了\n");
	return 0;
}
