/*************************************
敵発見を行う。

2014/12/03 by K.Mano and Y.Igarashi
****************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "header/col_extern.h"
#include "header/col_define.h"

int number_l=-1, number_r=-1;
//int color_x=-1,color_y=-1,color_lengh=-1;

CvRect rectmax;


int color_detect(int type/*0で前方カメラ、0以外で後方カメラ*/,int *color_x,int *color_y,int *color_lengh){
//*****変数定義*****
	//int caperr = 0;
	int i;
	int xy1[4], xy2[4];
	IplImage *input = 0;
	IplImage *mask = 0;
	IplImage *smooth = 0;


/******************** 画像取得 ****************************/
	printf("getimag%d\n",type);
	/*caperr =*/ get_img(input, IMG_X, IMG_Y,type);
/*	if(caperr != 0){	 //キャプチャが失敗したときの例外処理
		return -1;
	}
*/
	printf("colrimag\n");
	input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_COLOR);
//input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);


/******************* 色の摘出 *******************************/

	//cv_ColorExtraction(input, mask, CV_BGR2HSV, 175, 5, 150, 255, 100, 255);
	//cv_ColorExtraction(input, mask, CV_BGR2HSV, 175, 5, 150, 255, 100, 255);
	//printf("9873\n");	
if(type == 0) cv_ColorExtraction(input, mask, CV_BGR2HSV, 170, 10, 80, 255, 0, 255);//肌色が読まれる
	else cv_ColorExtraction(input, mask, CV_BGR2HSV, 175, 5, 150, 255, 100, 255);
	mask = cvLoadImage("./img/mask.jpg", CV_LOAD_IMAGE_ANYCOLOR);
	//printf("1234\n");

/******************** 平滑化 **********************************/

	color_smooth(mask,smooth,1);//入力、出力、画像の保存1,
	smooth = cvLoadImage("./img/gaus.jpg", CV_LOAD_IMAGE_ANYCOLOR);

/******************* ラベリング ********************************/
	int nums;
//	int xy[10][6];//k0-k2>幅だと思われwk4,hk5を代入するようにする
	
	//敵の場所をラベリング
	nums=color_labelling(smooth, &rectmax);

	printf("トリミングエリアとして抽出されたエリアの数 = %d\n",nums);

		//printf("cvcc\n");
/***************** 敵位置予測認識処理を行う *******************/


	printf("rectmax.height=%d\n",rectmax.height);

	printf("rectmax.width=%d\n",rectmax.width);


	if(nums!=0 && rectmax.height>=34 && rectmax.height>=40){

		*color_x= rectmax.x + rectmax.width/2;	//labelling領域の中心座標x

		*color_y= rectmax.y + rectmax.height/2;	//labelling領域の中心座標y

//		color_lengh = (-(201/90)*rectmax.height)+467.5;		//敵との距離予測　実測により近似
		*color_lengh = 45*280/rectmax.width;		//敵との距離予測　実測により近似
		//printf("rectmax.width = %d\n",rectmax.width);
	}
	else{
		printf("認識した赤が小さい。または、ラベリング出来なかった。 Can't search enemy.\n");
		*color_x= -1;
		*color_y= -1;
		*color_lengh = -1;
	}
	printf("color_dect_x=%d,color_y_dect = %d\n",color_x,color_y);
	//input = 0;
	//mask = 0;
	//smooth = 0;
	//cvReleaseImage(&input);
	//cvReleaseImage(&mask);
	//cvReleaseImage(&smooth);

}

