/*************************************
画像の平滑化を行う。(Medianフィルタ)

敵の発見にはGaussianフィルタより、Medianフィルタに
かけた方が良かった

2014/12/03 by K.Mano and Y.Igarashi
****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "header/col_define.h"

//画像の平滑化を行う
void color_smooth(IplImage *src/*入力画像*/,IplImage *gaus/*出力画像*/,int sflag/*保存するかのフラグ*/){
	IplImage *gray = 0;

	gray = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);
	gaus = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);

	gray=src;
	//cvCvtColor(src,gray,CV_BGR2GRAY);
	cvSmooth(gray, gaus, CV_MEDIAN, 9, 9, 0, 0);	//平滑化(Medianフィルタ CV_MEDIAN)


//#ifdef __DEBUG__
	if(sflag){
		cvSaveImage("./img/gray.jpg", gray, NULL);
		cvSaveImage("./img/gaus.jpg", gaus, NULL);
	}
//#endif

	cvReleaseImage(&gray);
	cvReleaseImage(&gaus);
}
