#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cv.h>
#include <highgui.h>
#include "image.h"

void getBallColor(IplImage *src_img,IplImage *red_img,int code,ImageHSV hsv){
    int i, k;    
    IplImage *Color_img;
    IplImage *ch1_img, *ch2_img, *ch3_img;
    IplImage *Mask_img;

    int lower[3];
    int upper[3];
    int val[3];

    CvMat *lut;    
    //codeɊÂJ[ϊ
    Color_img = cvCreateImage(cvGetSize(src_img), src_img->depth, src_img->nChannels);
    cvCvtColor(src_img, Color_img, code);
    //3ChLUT쐬
    lut    = cvCreateMat(256, 1, CV_8UC3);
    lower[0] = hsv.h.min;
    lower[1] = hsv.s.min;
    lower[2] = hsv.v.min;

    upper[0] = hsv.h.max;
    upper[1] = hsv.s.max;
    upper[2] = hsv.v.max;

    for (i = 0; i < 256; i++){
        for (k = 0; k < 3; k++){
            if (lower[k] <= upper[k]){
                if ((lower[k] <= i) && (i <= upper[k])){
                    val[k] = 255;
                }else{
                    val[k] = 0;
                }
            }else{
                if ((i <= upper[k]) || (lower[k] <= i)){
                    val[k] = 255;
                }else{
                    val[k] = 0;
                }
            }
        }
        //LUT̐ݒ
        cvSet1D(lut, i, cvScalar(val[0], val[1], val[2],0));
    }

    //3ChƂLUTϊie`lƂɂQlj
    cvLUT(Color_img, Color_img, lut);
    cvReleaseMat(&lut);
    //e`lƂIplImagemۂ
    ch1_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    ch2_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    ch3_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);

    //`lƂɓlꂽ摜ꂼ̃`lɕ
    cvSplit(Color_img, ch1_img, ch2_img, ch3_img, NULL);
    //3ChSĂANDA}XN摜쐬B
    Mask_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    cvAnd(ch1_img, ch2_img, Mask_img,0);
    cvAnd(Mask_img, ch3_img, Mask_img,0);
    //͉摜(src_img)̃}XN̈o͉摜(dst_img)փRs[
	cvZero(red_img);
    cvCopy(src_img, red_img, Mask_img);

    //
    cvReleaseImage(&Color_img);
    cvReleaseImage(&ch1_img);
    cvReleaseImage(&ch2_img);
    cvReleaseImage(&ch3_img);
    cvReleaseImage(&Mask_img);

}
