#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "header/col_define.h"

void smooth(IplImage *src,IplImage *dst, int sflag){
	IplImage *gray = 0;
	IplImage *gaus = 0;

	gray = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);
	gaus = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U,1);

	cvCvtColor(src, gray, CV_BGR2GRAY);	//グレースケール化
	cvSmooth(gray, gaus, CV_GAUSSIAN, 5, 0, 0, 0);	//平滑化(ガウシアンフィルタ)
	
#ifdef __DEBUG__
	if(sflag==1){
		cvSaveImage("./img/gray.jpg", gray, NULL);
		cvSaveImage("./img/gaus.jpg", gaus, NULL);
	}
#endif

	cvReleaseImage(&gray);
	cvReleaseImage(&gaus);
}
