/*
速度制御	2014/7/3
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "./../device/device.h"
#include "./../hardware.h"
#include "./../device/encoder.h"
#include "./../run/vel_ctrl.h"
#include "./../run/distance.h"
#include "hexagon.h"

static pthread_t tasks[1];
static int dist,mode;

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;

	while(1){
		counter++;

		distance_get(&distance_data);
		printf("dis_x=%6.1f    dis_y=%6.1f	dis_s=%6.1f\n",distance_data.x_dist, distance_data.y_dist
			,distance_data.shet);

		usleep((T_TEST-1)*1000); // 実行周期

	}

	//hexagon_cancel();
	//vel_ctrl_set(0., 0.);

	usleep(200000);

	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_hexagon(){

	int s_val;
	int speed;
	char dumy;

	//vel_ctrl_reset();

	encoder_create();
	vel_ctrl_create();



	while(1){

		printf("speed value [cm/s]= ");
		s_val=scanf("%d",&speed);
		s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
		printf("mode 1:y ,2:r30 , 3:l30 ");//1 前進後退、2右斜め、3左ななめ
		s_val=scanf("%d",&mode);
		s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
		printf("distance [cm]= ");
		s_val=scanf("%d",&dist);
		s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
		hexagon_set_speed((float)speed);
		hexagon_set_dist_mode((float)dist, mode);

		hexagon_create();
		thread_create();

		while(1){
			//printf("ctrl dist loop\n");
			if(hexagon_get_endflag()==1){
				//printf("get endflag!!!!\n");
				//hexagon_reset();
				//hexagon_stop();
				//distance_reset();
				break;
			}
			usleep(20000);
		}
		hexagon_reset();
		vel_ctrl_reset();
		pthread_cancel(tasks[0]);

	}

	hexagon_cancel();
	printf("thread_id=%d\n",(int)tasks[0]);

	pthread_join(tasks[0],NULL);
	//vel_ctrl_set((float)vel_l_ref, (float)vel_r_ref); 
	//hexagon_create(STRAIGHT);

	printf("Program stopped\n");

}


