// MIRSAK パトロール走行
//標準プログラムから変更
//五十嵐 眞野

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
#include "patrol_sequence.h"
#include "./../../hardware.h"
#include "./../../direction/direction.h"
#include "./../../run/run_ctrl.h"
#include "./../../hexagon/hexagon.h"

#include "./../../gazou/number/define.h"
#include "./../../gazou/number/extern.h"
#include "./../../gazou/header/col_extern.h"
#include "./../../gazou/header/col_define.h"
#include "./../../server/server_info.h"
/*
#include "./../../gazou_ex5/number/define.h"
#include "./../../gazou_ex5/number/extern.h"
//#include "./../../gazou_ex5/header/define.h"
#include "./../../gazou_ex5/header/extern.h"
#include "./../../gazou_ex5/header/define.h"
*/
#include "./../../device/io.h"//追加
#include <time.h>//タイマー用

//enum run_mode run_mode;

//static void get_patrol_data(int i, char *style, int *value)
static void get_patrol_data(int i, int *style, int *value_1, int *value_2)
{
	struct patrol_data *data;
	data = pt_data;
	*style=(data+i)->style;
	*value_1=(data+i)->value_1;
	*value_2=(data+i)->value_2;

}

//static enum run_mode run_mode=STRAIGHT;

//正体補正をするシーケンス番号,
static int dir_number[20] ={2,3,8};//距離がバラバラ 数字認識時に必ず使う<
static int dir_dir[20] ={0,1,0};//正対補正を行う方向
static int dir_dist_x[10] ={0,60,0};//距離用 x方向の距離
static int dir_dist_y[10] ={52,0,55};//距離用 y方向の距離

//数字認識するシーケンス番号	ランドマーク、宝
static int num_number[20] ={4,0};
static int land_number = 6;//ランドマークの番号
static int tr_number = 2;//宝認識のシーケンス番号
//数字認識するカメラの番号 0:前	1:後ろ
static int cum_number[20] ={0,0};

/*
//static int gcount =0;//追加
	//char goal[];//追加ゴールがどこにあるか
static char *goal;//追加ゴールがどこにあるか
int goal_type(int);//追加ゴール位置を決める エラー時 -1を返す
*/
//void err_number();//追加数字読み込みエラー時


void patrol(){
	float default_speed = 40.0; //直進速度[cm/sec] 
	float default_speed_rot = 40.0; //回転速度 [deg/sec]
	int max_sequence_num=10;//10 //終了までのシーケンス数
//	float speed;
	int sequence_num = 1;//シーケンス番号
//シーケンス動作用
	int dcount =0;
	int d_dist =0;//追加補正距離変更用
	int ncount =0;
/*	int gcount =0;//追加

	int face_distance = 50; //正体補正する距離	毎回変更するかも
	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）正対補正とわける。
	int num_distance = face_distance - CAM_USS_DIF ; 
*/	int num_distance = 50; // CAM_DIF ; //MIRS先端からカメラの距離、先端の距離と合わせる

	int numbers[2];
	int boad_number;//追加ボードの数字 1つの場合
	//int err_boad=0;//数字認識エラー回数

	int style=0;
	int value_1=0,value_2=0;
	int ret_val;
	//struct 
	number_ins number;//
	clock_t start, end;//追加時間用の変数宣言
	start = clock();//測定開始

	//number_set_nums(1); //ボード上の数字の数を1にセット

	//スタート
/*
	printf("wite now\n");
	while(1){
		if(sw_get(5)=='1')break;	
		//if(sw_get(8)=='1')break;//cahr型　タッチされまで停止
		usleep(100*1000);//newtouchsensa		
	}
*/
	printf("patrol start!\n");

	while(1){
		//動作開始
		get_patrol_data(sequence_num-1, &style, &value_1, &value_2); 
		printf("sequence_num=%d    style=%d  value1=%d value2=%d  \n", sequence_num, style, value_1,value_2);

		if(style==STRAIGHT){//移動

		hexagon_set_speed(default_speed);
		hexagon_set_dist_mode((float)value_1, (int)value_2);

		hexagon_create();

		while(1){
			if(hexagon_get_endflag()==1){
				break;
			}
			usleep(20000);
		}
		//printf("hexok?\n");
		hexagon_reset();
		//vel_ctrl_reset();
		//hexagon_cancel();
		hexagon_stop();
		}

		if(style==ROTATE){//旋回
			run_ctrl_set_shet_dist((float)value_1);
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
		// endflag が 1 になるまで loop する
		while(1){
			if(run_ctrl_get_endflag()==1) break;
			 usleep(20000);
		}

		run_ctrl_cancel();


		}

		//指定したシーケンスで正体補正する
		if(dir_number[dcount]==sequence_num){
				//補正距離を与える
			//int direct;//宣言が必要
			ret_val=direction_correct(dir_dir[dcount]);
			//ret_val=direction_correct(0);//前で正対補正
			ret_val=direction_bolok(dir_dist_y[d_dist],dir_dist_x[d_dist]);
			dcount++;
			d_dist++;
		}

		//指定したシーケンスで数字認識する		//ランドマーク、宝の確認＞送信する
		if(num_number[ncount] == sequence_num){
			while(1){
				ret_val = number_detect(num_distance,cum_number[ncount]); //数字認識 50cmスタート位置による
   				number_get(number);
				boad_number=number.num;

				if(num_number[ncount] == tr_number){
				//宝認識
	      				printf("宝の数字=%d\n",boad_number);				
				//データがあっているか確認
					if(boad_number%2!=0){
						ret_val = number_detect(num_distance,cum_number[ncount]); //数字認識 50cmスタート位置による
		   				number_get(number);
						boad_number=number.num;						
					}
				//データの送信
					server_info_treasure(boad_number);
	
					break;
				}else{
				//ランドマーク認識
    	  				printf("ランドマークの数字=%d\n",boad_number);				
					//if(boad_number == land_number)break;//ランドマーク認識成功
					//else direction_bolok(dir_dist[d_dist]);//ランドマーク失敗時は位置補正のみで進行？

				}

/*
				if(ret_val==-1){
					//情報送信
					break;
				}	//認識できたか
				err_boad++;
				usleep(100*1000);
				//認識できないとき
				if(err_boad>10){
					err_number();//戻ってやり直し
					sequence_num--;
					d_dist--;
					dcount--;
					err_boad=0;
					break;
				}
*/

			}

			ncount++;
		}


		//時間計測
		 end = clock();
		//特定時間が過ぎてシーケンスがあるときの動作変更
/*		if((end - start) >= 450 && sequence_num == num){//複数番号num1,num2>それに合ったシーケンスに飛ぶ
				printf("時間がないため動作をスキップします\n");
				sequence_num=;//スキップ
		}
*/
		sequence_num++;

	//終了シーケンス数になったら while を抜け、終了
		if(sequence_num > max_sequence_num){
			printf("終了します\n");	
			break;
		}

		usleep(1000*1000);

	}

	run_ctrl_stop();
	usleep(100*1000);

}

/*
void err_number(){
//数字認識エラー時20cm戻り位置補正から
//	run_ctrl_set(style, speed); 
//	run_ctrl_set_dist((float)value);
	printf("認識ミスのためやり直します\n");
	run_ctrl_set(STRAIGHT,-20); 
	run_ctrl_set_dist((float)-25.);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
		 usleep(20000);
	}
	run_ctrl_cancel();

}
*/

