//全体の制御を行う
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
#include "./../../device/device.h"
#include "./../../device/encoder.h"
#include "./../../run/vel_ctrl.h"
#include "./../../device/io.h"

int test_patrol(){

	int ret_val;

	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();

	encoder_create(); 
    vel_ctrl_create();


	patrol();
		
	device_encoder_close();
	device_motor_close();
	device_uss_close();
	device_io_close();

	return 0;

}

