/*
速度制御	2014/7/3
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "./../device/device.h"
#include "./../hardware.h"
#include "./../device/encoder.h"
#include "vel_ctrl.h"
#include "distance.h"
#include "run_ctrl.h"
#include"./../main/search/run.h"

static char mode;
static pthread_t tasks[1];
static int run_x_dist, run_y_dist, rot_angle;

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;

	while(1){
		counter++;

		distance_get(&distance_data);
		printf("dis_x=%6.1f    dis_y=%6.1f	dis_s=%6.1f\n",distance_data.x_dist, distance_data.y_dist
			,distance_data.shet);

		usleep((T_TEST-1)*1000); // 実行周期

	}

	//run_ctrl_cancel();
	//vel_ctrl_set(0., 0.);

	usleep(200000);
//	distance_get(&distance_data);
//	printf("dis_left=%6.1f    dis_right=%6.1f\n",distance_data.left, distance_data.right);

	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_run(){

	int s_val;
	int speed;
	char dumy;

	//vel_ctrl_reset();

	encoder_create();
	vel_ctrl_create();



	while(1){

		printf("run mode (s or r or a) = ");//移動、回転、すべて
		s_val=scanf("%c",&mode);
		s_val=scanf("%c",&dumy); //改行コードを読み飛ばす

			printf("speed value [cm/s]= ");
			s_val=scanf("%d",&speed);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			printf("distance_x [cm]= ");
			s_val=scanf("%d",&run_x_dist);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす
			printf("distance_y [cm]= ");
			s_val=scanf("%d",&run_y_dist);
			s_val=scanf("%c",&dumy); //改行コードを読み飛ばす

		run(speed,run_x_dist,run_y_dist);


		thread_create();


		vel_ctrl_reset();
		pthread_cancel(tasks[0]);

	}


	printf("thread_id=%d\n",(int)tasks[0]);

	pthread_join(tasks[0],NULL);
	//vel_ctrl_set((float)vel_l_ref, (float)vel_r_ref); 
	//run_ctrl_create(STRAIGHT);

	printf("Program stopped\n");

}


