/*
針機構用のモーターを動かす
動かす量は決まっていて、針の展開、回収が終わるまで続ける

*/
#include <linux/errno.h>
#include <sys/io.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <stdio.h>

#include "device.h"
#include "needle.h"
#include "math.h"
#include "./../hardware.h"


//static float Du = 1.0; 

//void motor_drive(float u_l, float u_r ){
static int mode = OFF;//モード

void needle(int onoff){

	int output_duty_n;        //Duty比にしたもの
//	int final_output_n;      //最終的に書きこむ値
	int cnt = 0;//カウンター
	int ret_val;
        unsigned char m_data[1];

	int fd_needle;
	fd_needle = device_needle_get();
		
	if(onoff == ON && mode == OFF){
        	output_duty_n = SPEED;
		mode = ON;
		m_data[0]=output_duty_n;
        //m_data[0]=final_output_n;
		while(cnt < 380){
//	while(cnt < END_CUNT){
			ret_val = write(fd_needle,m_data,1);//書き込み
			usleep((T_TEST-1)*1000);
			cnt++;
		}
	}else if(onoff == OFF&& mode == ON){
        	output_duty_n = SPEED+128;
		mode = OFF;
		m_data[0]=output_duty_n;
        //m_data[0]=final_output_n;
		while(cnt < 345){
//	while(cnt < END_CUNT){
			ret_val = write(fd_needle,m_data,1);//書き込み
			usleep((T_TEST-1)*1000);
			cnt++;
		}
	}else{
       		output_duty_n = 0;
		m_data[0]=output_duty_n;
		ret_val = write(fd_needle,m_data,1);//書き込み
	}
/*
	m_data[0]=output_duty_n;
        //m_data[0]=final_output_n;
	while(cnt < 140){
//	while(cnt < END_CUNT){
		ret_val = write(fd_needle,m_data,1);//書き込み
		usleep((T_TEST-1)*1000);
		cnt++;
	}
*/
	m_data[0]=0;//stop
        ret_val=write(fd_needle,m_data,1);//書き込み

}

