// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "device.h"
#include "./../hardware.h"
#include "encoder.h"

static pthread_t tasks[1];
//static int pwm_duty_r, pwm_duty_l;

static void *thread_code(void *t){

	FILE *fp;
	int counter=0;
	//int ret_val;
	struct encoder_data encoder_data;

	fp=fopen("test.data","w");

	printf("enc_left \t enc_right \t  enc_left_sum \t enc_right_sum\n");

	while(1){
		counter++;

		//if(counter > 200) break;

		//encoder_read(&encoder_data);
		encoder_get(&encoder_data);
		//printf("counter=%5d left=%5d  right=%5d left_sum=%5d right_sum=%5d\n",counter,encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);
		printf("left=%5d    right=%5d  back=%5d left_sum=%5d   right_sum=%5d back_sum=%5d\n",encoder_data.left,
			encoder_data.right,encoder_data.back,encoder_data.left_sum, encoder_data.right_sum,encoder_data.back_sum);

		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価
		usleep((T_TEST-1)*1000);

	}

	fclose(fp);
	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_encoder(){

/*
	int s_val;
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
*/

	thread_create();
	encoder_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


