/*************************************
敵認識のテストを行う。

2014/12/03 by K.Mano and Y.Igarashi
****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "./header/col_extern.h"

int color_x,color_y,color_lengh;

int main(){
	int count =1;
	int i;

	printf("色認識テストプログラムスタート！\n");
	printf("数字を入力。0なら前方カメラ、0意外なら後方カメラ\n");
	scanf("%d",&i);

	while(1){		//無限ループ

		color_detect(i,&color_x,&color_y,&color_lengh);	//前のカメラ=0、後ろのカメラは0以外

		printf("%d 回目：色発見、位置 x=%d,y=%d,距離=%d\n",count, color_x,color_y,color_lengh);

		if(color_x == -1 || color_y == -1){		//画像認識失敗で再画像認識ループへ
			count++; // 再度画像処理
		}else{
			printf("画像認識完了しました\n");
			break;
		}

		if(count>10){
			printf("数字認識に%d回失敗しました。\n",count-1);
			return -1;
		}

		//printf("メイン一周終了\n");
		usleep(1*1000*1000); //一秒待つ

			

	}

	printf("メインwhileの終了\n");
	return 0;
}
