/**********************************************************
ԐFo
QlFhttp://imagingsolution.blog107.fc2.com/?mode=m&no=248

by Y.Igarashi
**********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>//CN[hɂȂɂKv?
#include "header/col_define.h"

//---------------------------------------------------------------  
//y֐@zFcv_ColorExtraction  
//yTvzFFo  
//y@@zFsrc_img        = ͉摜(8bit3ch)  
//@@@@@@Fdst_img        = o͉摜(8bit3ch)  
//@@@@@@Fmask_img       = o͉摜(8bit3ch)  
//@@@@@@Fcode        = FԂ̎wiCV_BGR2HSV,CV_BGR2LabȂǁj
//@@@@@@Fch1_lower    = ch1̂l()
//@@@@@@Fch1_upper    = ch1̂l()
//@@@@@@Fch2_lower    = ch2̂l()
//@@@@@@Fch2_upper    = ch2̂l()
//@@@@@@Fch3_lower    = ch3̂l() 
//@@@@@@Fch3_upper    = ch3̂l()
//y߂l@zFȂ  
//yl@@zFlower <= uppeȑꍇAlowerȏupperȉ͈̔͂𒊏oA
//@@@@@@Flower >  uppeȑꍇAupperȉlowerȏ͈̔͂𒊏o܂B
//--------------------------------------------------------------- 
int cv_ColorExtraction(IplImage* src_img, IplImage* outmask_img, 
                            int code,
                            int ch1_lower, int ch1_upper, 
                            int ch2_lower, int ch2_upper, 
                            int ch3_lower, int ch3_upper
                        ){

    int i, k;    

    IplImage *Color_img;
    IplImage *ch1_img, *ch2_img, *ch3_img;
    IplImage *Mask_img;

    int lower[3];
    int upper[3];
    int val[3];

    CvMat *lut;    
    //codeɊÂJ[ϊ 
    Color_img = cvCreateImage(cvGetSize(src_img), src_img->depth, src_img->nChannels);
    cvCvtColor(src_img, Color_img, code);
  
    //3ChLUT쐬
    lut    = cvCreateMat(256, 1, CV_8UC3);

    lower[0] = ch1_lower;
    lower[1] = ch2_lower;
    lower[2] = ch3_lower;

    upper[0] = ch1_upper;
    upper[1] = ch2_upper;
    upper[2] = ch3_upper;

    for (i = 0; i < 256; i++){
        for (k = 0; k < 3; k++){
            if (lower[k] <= upper[k]){
                if ((lower[k] <= i) && (i <= upper[k])){
                    val[k] = 255;
                }else{
                    val[k] = 0;
                }
            }else{
                if ((i <= upper[k]) || (lower[k] <= i)){
                    val[k] = 255;
                }else{
                    val[k] = 0;
                }
            }
        }
        //LUT̐ݒ//4ڂ̈͂悭
        cvSet1D(lut, i, cvScalar(val[0], val[1], val[2],0));
    }

    //3ChƂLUTϊie`lƂɂQlj
    cvLUT(Color_img, Color_img, lut);
    cvReleaseMat(&lut);

    //e`lƂIplImagemۂ
    ch1_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    ch2_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    ch3_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);

    //`lƂɓlꂽ摜ꂼ̃`lɕ
    cvSplit(Color_img, ch1_img, ch2_img, ch3_img, NULL);

    //3ChSĂANDA}XN摜쐬B
    Mask_img = cvCreateImage(cvGetSize(Color_img), Color_img->depth, 1);
    cvAnd(ch1_img, ch2_img, Mask_img, NULL);
    cvAnd(Mask_img, ch3_img, Mask_img, NULL);

//}XN摜̏o
    cvSaveImage("./img/mask.jpg", Mask_img, NULL);
    //outmask_img = Mask_img;
	outmask_img = cvLoadImage("./img/mask.jpg", CV_LOAD_IMAGE_ANYCOLOR);
    //͉摜(src_img)̃}XN̈o͉摜(dst_img)փRs[
    //cvZero(dst_img);
    //cvCopy(src_img, dst_img, Mask_img);

    //
    cvReleaseImage(&Color_img);
    cvReleaseImage(&ch1_img);
    cvReleaseImage(&ch2_img);
    cvReleaseImage(&ch3_img);
    cvReleaseImage(&Mask_img);

}
