/*************************************
敵の動きの予測を行う。

画像を2枚とって、敵の中心座標のずれから
移動方向を予測する。

2014/12/20 by K.Mano
****************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "header/col_extern.h"
#include "header/col_define.h"

extern int color_x;

int main(void){
	int type;
	int x[2];

	printf("敵の動きを予測します。\n");
	printf("使うカメラを指定してください。前方カメラ：0  後方カメラ：1\n");
	scanf("%d",&type);

	color_detect(type);
	x[0] = color_x;
	
	color_detect(type);
	x[1] = color_x;

	//敵が発見できなかったらcolor_xに-1が入る
	if(x[0] == -1 || x[1] == -1) printf("敵の位置を予測できません。\n");
	else if(x[0] - x[1] > 0) printf("敵は画像の左側に移動\n");
	else if(x[0] - x[1] < 1) printf("敵は画像の右側に移動\n");
	else printf("敵は移動してない。\n");


	return 0;


}
