#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cv.h>
#include <highgui.h>
#include "geometry.h"

Circle getCenterPoint(IplImage* binr_img){
	Circle ball;
	CvMoments moments;
	cvMoments(binr_img,&moments,0);
	double m00 = cvGetSpatialMoment(&moments,0,0);
	double m10 = cvGetSpatialMoment(&moments,1,0);
	double m01 = cvGetSpatialMoment(&moments,0,1);
	ball.center.x = m10/m00 / 320.;
	ball.center.y = m01/m00 / 320.;
	ball.radius = sqrt((m00/255)/(M_PI)) / 320.;
	ball.isCCW = 0;
	return ball;
}
