//全体の制御を行う
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
#include "./../../device/device.h"
#include "./../../device/encoder.h"
#include "./../../run/vel_ctrl.h"
#include "./../../device/io.h"

int test_destroy(){

	int mode;
	int ret_val;

	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();
	ret_val=device_lamp_open();
	ret_val=device_needle_open();

	encoder_create(); 
    	vel_ctrl_create();
	
	printf("0ならFRONTならREAR\n");
	scanf("%d",&mode);

	printf("destroy mode start!!\n");
	printf("mode = %d\n",mode);
	destroy(mode);
	printf("destroy mode finish!\n");	

	device_encoder_close();
	device_motor_close();
	device_uss_close();
	device_io_close();
	device_lamp_close();
	device_needle_close();

	return 0;

}

