/*

五十嵐　変更　2014/12/2



*/

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "./../../hardware.h"
#include "./../../device/encoder.h"
#include "./../../device/motor.h"
#include "./../../device/needle.h"

static pthread_t tasks[1];

static on_off = OFF;

static void *thread_code(void *t){
	while(1){
		needle(on_off);
	}
	pthread_exit(0);
}


static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;
	int policy;

	pthread_attr_init(&attr);

	 // 優先度5、ポリシーFIFOでスレッド生成
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	pthread_setschedparam(pthread_self(), SCHED_FIFO , &sched_param);

	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	pthread_getschedparam(pthread_self(), &policy, &sched_param);
	printf("plicy = %s, priority =%d\n",
		(policy == SCHED_FIFO)  ? "SCHED_FIFO" :
		(policy == SCHED_RR)    ? "SCHED_RR" :
		(policy == SCHED_OTHER) ? "SCHED_OTHER" :
		"???",
 		sched_param.sched_priority);

	return 0;
}


void needle_create(set){
	on_off = set;
	thread_create();

}

void needle_cancel(){
	pthread_cancel(tasks[0]);

}


