/************************************************************
宝が怪盗に盗まれた場合に索敵で小部屋まで行った後に
「小部屋内を索敵して怪盗追跡する動作」

2015.1.23 by K.Mano
************************************************************/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
//#include "patrol_sequence.h"
#include "./../../hardware.h"
#include "./../../direction/direction.h"
#include "./../../run/run_ctrl.h"
#include "./../../gazou/number/extern.h"
#include "./../../gazou/header/col_extern.h"//怪盗認識
#include "./../../device/io.h"
#include "./../../device/lamp.h"
#include "./../../device/needle.h"
#include "./../../device/uss.h"
#include "./../../run/distance.h"
#include "./../../server/server_info.h"
#include "./../search/run.h"

#define USS_FR 1
#define USS_FL 3
#define USS_RF 4
#define USS_RR 2

int destroy_room(){
	const float default_speed = 40.0; //直進速度[cm/sec] 
	const float default_speed_rot = 20.0; //回転速度 [deg/sec]


	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）正対補正とわける。

//	int num_distance = 50; // CAM_DIF ; //MIRS先端からカメラの距離、先端の距離と合わせる



/*************************************************/
	int x=1;
	int y=100;
	int color_x,color_y,color_length;
	int dir=0;	//後ろ(-1)か前(1)か
	int uss[5]={0,0,0,0,0};
	int room;

	while(1){
		x=0;
		color_detect(FRONT,&color_x,&color_y,&color_length);
		if(color_x != -1){
			x = x * (color_x - 320);
			dir = 1;
		}else{
			color_detect(REAR,&color_x,&color_y,&color_length);
			if(color_x != -1){
				x = x * (color_x - 320);
				dir = -1;
			}
		}

		if(x==0){
			y=0;			
		}else{
			y=100;
		}

		room = server_info_thief();
		if(room!=-1) break;	//新たに宝が盗まれたらループ抜ける
		if(color_x == -1) continue;	//前も後ろもいなかったら撮りつづける
		else{
			//run_ctrl_reset();
			run_ctrl_set_speed(default_speed);
			run_ctrl_set_xy_dist(x, dir*y);	
			if(run_ctrl_get_endflag()==1){
				run_ctrl_cancel();
				run_ctrl_create();				//走行のスレッド生成
			}

		}

		if(server_info_capture()==1) return 100;
		
	}
	run_ctrl_set_shet_dist(45.);
	while(1){
		if(run_ctrl_get_endflag()==1) break;
		 usleep(20000);
	}

	uss[USS_FR] = uss_get(USS_FR);
	uss[USS_FL] = uss_get(USS_FL);
	uss[USS_RF] = uss_get(USS_RF);
	uss[USS_RR] = uss_get(USS_RR);
	
	if(uss[USS_FR] == 9999 && uss[USS_FL] == 9999){
		run_ctrl_set_shet_dist(180.);//180度旋回
		run_ctrl_set_speed(default_speed_rot);
		run_ctrl_create();
		// endflag が 1 になるまで loop する
		while(1){
			if(run_ctrl_get_endflag()==1) break;
			 usleep(20000);
		}
		uss[USS_FR] = uss_get(USS_FR);
		uss[USS_FL] = uss_get(USS_FL);
		uss[USS_RF] = uss_get(USS_RF);
		uss[USS_RR] = uss_get(USS_RR);
	}
	if((uss[USS_FL]>90 && uss[USS_FL]<110) || (uss[USS_FR]>90 && uss[USS_FR]<110)){
		run(default_speed,0,-100);
	}else {
		run(default_speed,0,-150);
	}

}


