// MIRSAK パトロール走行
//標準プログラムから変更
//五十嵐 眞野

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
#include "patrol_sequence.h"
#include "./../../hardware.h"
#include "./../../direction/direction.h"
#include "./../../run/run_ctrl.h"
#include "./../../hexagon/hexagon.h"

#include "./../../gazou/number/define.h"
#include "./../../gazou/number/extern.h"
#include "./../../gazou/header/col_extern.h"
#include "./../../gazou/header/col_define.h"
#include "./../../server/server_info.h"
#include "./../search/run.h"
/*
#include "./../../gazou_ex5/number/define.h"
#include "./../../gazou_ex5/number/extern.h"
//#include "./../../gazou_ex5/header/define.h"
#include "./../../gazou_ex5/header/extern.h"
#include "./../../gazou_ex5/header/define.h"
*/
#include "./../../device/io.h"//追加
#include "./../../device/needle.h"//追加
#include <time.h>//タイマー用

//enum run_mode run_mode;

//static void get_patrol_data(int i, char *style, int *value)
static void get_patrol_data(int i, int *style, int *value_1, int *value_2)
{
	struct patrol_data *data;
	data = pt_data;
	*style=(data+i)->style;
	*value_1=(data+i)->value_1;
	*value_2=(data+i)->value_2;

}

//static enum run_mode run_mode=STRAIGHT;

//正体補正をするシーケンス番号,
static int dir_number[20] ={2,4,5};//距離がバラバラ 数字認識時に必ず使う<
static int dir_dir[20] ={0,1,1};//正対補正を行う方向
static int dir_dist_x[10] ={0,60,60};//距離用 x方向の距離
static int dir_dist_y[10] ={58,0,0};//距離用 y方向の距離

//数字認識するシーケンス番号	ランドマーク、宝
static int num_number[20] ={2,0};
static int land_number = 6;//ランドマークの番号
static int tr_number = 2;//宝認識のシーケンス番号
//数字認識するカメラの番号 0:前	1:後ろ
static int cum_number[20] ={0,0};

/*
//static int gcount =0;//追加
	//char goal[];//追加ゴールがどこにあるか
static char *goal;//追加ゴールがどこにあるか
int goal_type(int);//追加ゴール位置を決める エラー時 -1を返す
*/
//void err_number();//追加数字読み込みエラー時


void patrol(){
	float default_speed = 40.0; //直進速度[cm/sec] 
	float default_speed_rot = 40.0; //回転速度 [deg/sec]
	int max_sequence_num=6;//10 //終了までのシーケンス数
//	float speed;
	int sequence_num = 1;//シーケンス番号
//シーケンス動作用
	int dcount =0;
	int d_dist =0;//追加補正距離変更用
	int ncount =0;
/*	int gcount =0;//追加

	int face_distance = 50; //正体補正する距離	毎回変更するかも
	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）正対補正とわける。
	int num_distance = face_distance - CAM_USS_DIF ; 
*/	int num_distance = 50; // CAM_DIF ; //MIRS先端からカメラの距離、先端の距離と合わせる

	int numbers[2];
	int boad_number;//追加ボードの数字 1つの場合
	//int err_boad=0;//数字認識エラー回数

	int style=0;
	int value_1=0,value_2=0;
	int ret_val;
	//struct 
	number_ins number;//
	clock_t start, end;//追加時間用の変数宣言
	start = clock();//測定開始

	run_ctrl_set_xy_dist(0,100);
	run_ctrl_set_speed(default_speed);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
	}

	direction_correct(1);
	run_ctrl_set_xy_dist(0,100);
	run_ctrl_set_speed(default_speed);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
	}

	run_ctrl_stop();
	run_ctrl_cancel();
	usleep(100*1000);

	needle_create(ON);

}

/*
void err_number(){
//数字認識エラー時20cm戻り位置補正から
//	run_ctrl_set(style, speed); 
//	run_ctrl_set_dist((float)value);
	printf("認識ミスのためやり直します\n");
	run_ctrl_set(STRAIGHT,-20); 
	run_ctrl_set_dist((float)-25.);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
		 usleep(20000);
	}
	run_ctrl_cancel();

}
*/

