//全体の制御を行う
//main
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
#include "./../../device/device.h"
#include "./../../device/encoder.h"
#include "./../../run/vel_ctrl.h"
#include "./../../device/io.h"



int test_search(){

	int ret_val;
	int dir;
	//デバイスオープン
	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();
	ret_val=device_lamp_open();
	ret_val=device_needle_open();
	//エンコーダ、速度制御スレッドの生成
	encoder_create(); 
    	vel_ctrl_create();


	dir = search(); //索敵 返り血は発見したカメラの向き
	printf("search mode finish. dir=%d\n",dir);

	//デバイスのクローズ
	device_encoder_close();
	device_motor_close();
	device_uss_close();
	device_io_close();
	device_lamp_close();
	device_needle_close();
	return 0;

}

