// MIRSAK パトロール走行
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
//#include "patrol_sequence.h"
#include "./../../hardware.h"
//#include "./../../run/direction.h"
#include "./../../run/run_ctrl.h"
/*
#include "./../../gazou_ex5/number/define.h"
#include "./../../gazou_ex5/number/extern.h"
//#include "./../../gazou_ex5/header/define.h"
#include "./../../gazou_ex5/header/extern.h"
#include "./../../gazou_ex5/header/define.h"
*/
#include "./../../gazou/number/define.h"
#include "./../../gazou/number/extern.h"
#include "./../../gazou/header/col_extern.h"
#include "./../../gazou/header/col_define.h"
#include "./../../server/server_info.h"

#include "./search_threadD.h"

#include "./../../device/io.h"
#include "./../../device/lamp.h"
//#include "./../../device/needle.h"
#include "run.h"
//#include "search_sequence.h"
#include "center.h"
//#include "search.h"

#include<math.h>


#define __DEBUG__

void room_in(char);		//小部屋入出(小部屋記号A,B,C,D)
void room_out(char);	//小部屋退出(小部屋記号)

	static const float default_speed = 40.0; //直進速度[cm/sec] 
	static const float default_speed_rot = 40.0; //回転速度 [deg/sec]
	static const float repair_speed = 20.0;	//補正速度[cm/sec]

int search(){

	//int max_sequence_num=13; //終了までのシーケンス数
	float speed;
	int sequence_num=1;
	int dcount =0;
	int d_dist =0;//追加補正距離変更用
	//int ncount =0;
	//int gcount =0;//追加

	int angle=1;//90度回転してて4方向のどの方向向いてるか。%で余りで使う　0:上、1:右、2:下、3:左 patrolとの関係上,初期値は1

	int face_distance = 50; //正体補正する距離	毎回変更するかも
	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）正対補正とわける。
	int num_distance = face_distance - CAM_USS_DIF ; 
//	int num_distance = 50; // CAM_DIF ; //MIRS先端からカメラの距離、先端の距離と合わせる

	int numbers[2];
	int boad_number;//追加ボードの数字 1つの場合
	int err_boad=0;//数字認識エラー回数
	int style=0;
	int value_1=90,value_2=0;

	int enemy_x=-1,enemy_y=-1,enemy_lengh=-1;

	int select_B; //部屋Bのときの方向　0:上の入り口　1:左の入り口


	int room ;// (char)server_info_thief();


	//number_set_nums(1); //ボード上の数字の数を1にセット

	//server_create();	//小部屋情報受信スレッド作成

	//スタート



	printf("Serch mode start!\n");
	server_info_init();
	while(1){
		angle++;//++
		run_ctrl_set_shet_dist(-1.*(float)value_1);//90度旋回
		run_ctrl_set_speed(default_speed_rot);
		run_ctrl_create();
		// endflag が 1 になるまで loop する
		while(1){
			if(run_ctrl_get_endflag()==1) break;
			 usleep(20000);
		}
		
		run_ctrl_cancel();
#ifdef __DUBUG__
		printf("rotation finish\n");
#endif 
		printf("searching front\n");
		color_detect(0,&enemy_x,&enemy_y,&enemy_lengh);//前怪盗索敵
		if(enemy_x!=-1){
			//server_cancel();	//小部屋情報受信スレッドキャンセル
			printf("前方に怪盗発見 enemy is front\n");	

			//lamp(ON);
			return FRONT;	//前方にenemyがいることを返してsearch終了
		}
		
		printf("searching rear\n");
		color_detect(1,&enemy_x,&enemy_y,&enemy_lengh);//後ろ怪盗索敵
		if(enemy_x!=-1){
			//server_cancel();	//小部屋情報受信スレッドキャンセル
			printf("後方に怪盗発見 enemy is rear\n");	
			//lamp(ON);
			return REAR;	//後方にenemyがいることを返してsearch終了
		}
		room =	server_info_thief();//小部屋情報受信
		printf("room=%d\n",room);
		if(room != -1){//小部屋情報受信
			printf("小部屋モードに移行\n");	
			break;	//無限ループwhileを抜けて小部屋に移動
		}

	}
	
		//if(){}//補正動作＞どのタイミングで行うか



	/************************
		小部屋モード
	**************************/
	//どの小部屋か＜受信情報から
	
	/*	カメラを移動方向に向ける＞前は怪盗索敵　後ろはランドマーク用
		カメラスレッド作成
		小部屋に移動＞カメラ
	*/

	//server_cancel();	//小部屋情報受信スレッドキャンセル


	//移動方向決定>何かに書いておく
	//発見時にループを抜ける
	run_ctrl_cancel();
	search_threadD_create();	//スレッドD(詳細設計のフローチャート参照)を作成

	angle = angle % 4;


/*
	room ABCD  -> 1234
	angle	0:上、1:右、2:下、3:左

*/
	printf("angle=%d\troom=%d\n",angle,room);

	switch(angle){
	case 0:
		switch(room){
		case 1:
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			};
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(0,-100);

			break;
		case 3:	
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			}
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(150,0);

			break;
		case 4:
			run_ctrl_set_xy_dist(0,-150);

			break;
		}
		break;
	case 1:
		switch(room){
		case 1:
			run_ctrl_set_xy_dist(0,100);
			break;
		case 3:
			run_ctrl_set_xy_dist(0,-100);
			break;
		case 4:
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			}
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(0,-150);

			break;
		}

		break;

	case 2:
		switch(room){
		case 1:
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			}
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(0,100);
			break;
		case 3:
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			}
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(0,-150);
			break;
		case 4:
			run_ctrl_set_xy_dist(0,150);
			break;
		}
		
		break;

	case 3:
		switch(room){
		case 1:
			run_ctrl_set_xy_dist(0,-100);
			break;
		case 3:
			run_ctrl_set_xy_dist(0,150);
			break;
		case 4:
			run_ctrl_set_shet_dist((float)value_1);//90度旋回
			run_ctrl_set_speed(default_speed_rot);
			run_ctrl_create();
			// endflag が 1 になるまで loop する
			while(1){
				if(run_ctrl_get_endflag()==1) break;
				 usleep(20000);
			}
			run_ctrl_cancel();
			run_ctrl_set_xy_dist(0,100);
			break;
		}
		break;
	}

	run_ctrl_set_speed(default_speed);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
		if(search_threadD_get()!= -1) return search_threadD_get();
		 usleep(20000);
	}
	run_ctrl_cancel();
	run_ctrl_reset();
	run_ctrl_set_shet_dist(45.);
	run_ctrl_set_speed(default_speed_rot);
	run_ctrl_create();
	while(1){
		if(run_ctrl_get_endflag()==1) break;
		 usleep(20000);
	}
	run_ctrl_cancel();
	//room_in(room);

	/* ここに小部屋内を見渡すようなの */	
	

	//中央へ戻る

	//ループ終了

	//上のループへ戻る＞gotoでいい?

	run_ctrl_stop();
	usleep(100*1000);
	return -1;

}


void room_in(char room){
	number_ins numb;
	
	//ランドマークの前にいるのかどうか
	number_detect(100,REAR);	//距離100cmで後方カメラで数字認識
	number_get(numb);

	switch(room){
		case 1: //if(numb.num!=1) ;	//小部屋Aのランドマークと違ったら

		case 2: //if(numb.num!=5 && numb.num!=9) ;//小部屋Bのランドマークと違ったら

		case 3: //if(numb.num!=3) ;	//小部屋C

		case 4: //if(numb.num!=7) ;//小部屋D

		default : printf("小部屋%cは存在しない!!\n",room);
	}	
	//数字が真ん中にない
	int error_x = (numb.x-320)*(320/(100/sqrt(3)));
	//カメラの視野角を60度としたときのx方向の誤差
	//*の後ろが1px分の長さ、100が直角方向の距離
		run(repair_speed,-error_x,0.);

		//小部屋に入る
		run(default_speed,0.,50.);


}


void room_out(char room){
	number_ins numb;
	
	//ランドマークの前にいるのかどうか
	number_detect(150,FRONT);	//距離100cmで後方カメラで数字認識
	number_get(numb);

	switch(room){
		case 1: //if(numb.num!=1) ;	//小部屋Aのランドマークと違ったら

		case 2: //if(numb.num!=5 && numb.num!=9) ;//小部屋Bのランドマークと違ったら

		case 3: //if(numb.num!=3) ;	//小部屋C

		case 4: //if(numb.num!=7) ;//小部屋D

		default : printf("小部屋%cは存在しない!!\n",room);
	}	
	
	//数字が真ん中にない
	float error_x = (float)((numb.x-320)*(320/(150/sqrt(3))));
	//カメラの視野角を60度としたときのx方向の誤差
	//*の後ろが1px分の長さ、150が直角方向の距離
	run(repair_speed,-error_x,0.);

	//小部屋から出る
	run(default_speed,0.,50.);


}

