/*
位置情報のファイルを作成するモジュール
2015/1/14 五十嵐
*/

#include <stdio.h>
#include <sys/io.h>
#include <unistd.h>
#include <pthread.h>
#include "map.h"
#include "./../run/distance.h"
#include <math.h>


//static struct encoder_data encoder_data;
static pthread_t thread_id;
static int map_x=0;
static int map_y=0;
static float run_x=0;
static float run_y=0;
static float add_x=0;
static float add_y=0;
static float run_shet=0;
static int angle = 0;

int x_an(int);//anlge
int y_an(int);


void map_reset(){

        map_x = 0;
        map_y = 0;
	run_shet = 0;
        add_x = 0;
        add_y = 0;

}

void *map_read(void *t){

	FILE *fp;
	
	struct distance_data map_data;
	
	while(1){
		//位置情報の読み取り＜初期位置については触れていない
		distance_sum_get(&map_data);
		//angle = 3.14/180. * (run_shet + MAP_SHET);//角度計算
		//run_x = map_data.x_dist * cos(angle) + add_x+map_data.y_dist * sin(angle);
		//run_y = map_data.y_dist * sin(angle) + add_y+map_data.x_dist * sin(angle);

		run_x = map_data.x_dist * x_an(angle) + map_data.y_dist * y_an(angle) + add_x;
		run_y = map_data.y_dist * x_an(angle) + map_data.x_dist * y_an(angle) + add_y;

	//	run_x = map_data.x_dist + map_x;
	//	run_y = map_data.y_dist + map_y;
	//	printf("map_x=%f\tmap_y=%f\n",run_x,run_y);		

		map_x = (int)(run_x/50) + MAP_X;
		map_y = (int)(run_y/50)+ MAP_Y;
		printf("map_x=%d\tmap_y=%d\n",map_x,map_y);		
		if(map_x<0)map_x=0;
		if(map_y<0)map_y=0;
		if(map_x>8)map_x=8;
		if(map_y>8)map_y=8;

		//sleep(1);
		printf("x=%d\ty=%d\n",map_x,map_y);		
		if((fp=fopen("map.txt","w"))==NULL) printf("can't open file\n");//ファイルオープン
		fprintf(fp,"%d\t%d\n",map_x,map_y);//書き込み
	//	fprintf(fp,"%d",map_y);
		fclose(fp);		//ファイルクローズ
		//usleep(50*MAP_TIME); // 1ms はスケジューラの精度で遅
		sleep(1);
	}


}

static int thread_create()
{
        pthread_attr_t attr;
        struct sched_param sched_param;
        int ret;
        int policy;

        pthread_attr_init(&attr);

        sched_param.sched_priority = 5;//優先度低めで作成
        pthread_attr_setschedparam(&attr, &sched_param);
        pthread_setschedparam(pthread_self(), SCHED_FIFO , &sched_param);

        ret = pthread_create(&thread_id, &attr, map_read , (void *)2);

	 // 優先度5, ポリシーFIFOでスレッド生成
        pthread_getschedparam(pthread_self(), &policy, &sched_param);
        printf("policy = %s, priority =%d\n",
                (policy == SCHED_FIFO)  ? "SCHED_FIFO" :
                (policy == SCHED_RR)    ? "SCHED_RR" :
                (policy == SCHED_OTHER) ? "SCHED_OTHER" :
                "???",
                sched_param.sched_priority);

        return 0;
}



void map_rewrite(float x,float y){
//位置情報を修正する
	run_x = x ;
	run_y = y ;

}

void map_create(){

        map_reset();
        thread_create();
        printf("map_thread_id=%d\n",(int)thread_id);

}
void map_get(int *m_x,int *m_y){

	*m_x = map_x;
	*m_y = map_y;
}
//	MIRSが回転するときに変更する
void map_angle(float dir){
	angle = (int)dir;//90 or -90 only
	map_add(map_x,map_y);//更新
	distance_all_reset();
}
//位置情報を追加
void map_add(float x,float y){

	add_x += x; 
	add_y += y;
}
int x_an(int dir){
	if(dir==0){
		return 1;
	}else if(dir/90==2 ||dir/90 == -2 ){
		return -1;
	}else{
		return 0;
	}		
}
int y_an(int dir){
	if(dir/90 == 1 || dir/90 == -1){
		return 1;
	}else if(dir/90==3 ||dir/90 == -3 ){
		return -1;
	}else{
		return 0;
	}		
}


