/*
速度制御	2014/7/3
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "run_ctrl.h"
#include "./../hardware.h"
#include "./../device/encoder.h"
#include "vel_ctrl.h"
#include "distance.h"

static pthread_t tasks[1];
//static int pwm_duty_r, pwm_duty_l;

static void *thread_code(void *t){

	FILE *fp;
	int counter=0;
	//int ret_val;
	//struct encoder_data encoder_data;
	float left_spd, right_spd,back_spd;
	struct distance_data distance_data;
	fp=fopen("test.data","w");

	//printf("enc_left \t enc_right \t  enc_left_sum \t enc_right_sum\n");

	while(1){
		counter++;

		//if(counter > 200) break;

		//encoder_get(&encoder_data);
		//printf("left=%5d    right=%5d   left_sum=%5d   right_sum=%5d\n",encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);

		vel_ctrl_get_speed(&left_spd, &right_spd ,&back_spd);
		fprintf(fp,"left speed=%5.1f     right speed=%5.1fback speed=%5.1f\n",left_spd, right_spd,back_spd);	
		distance_get(&distance_data);//x,y方向の移動距離
		fprintf(fp,"distance_x=%8.3f    distance_y=%8.3f distance_s=%8.3f\n",distance_data.x_dist,distance_data.y_dist,distance_data.shet);

		usleep((T_TEST-1)*1000); // 実行周期

	}

	fclose(fp);
	return 0;
}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_vel_ctrl(){

	int s_val;
	int vel_r_ref, vel_l_ref, vel_b_ref;

	printf("right speed value [cm/s]= ");
	s_val=scanf("%d",&vel_r_ref);
	printf("left speed value [cm/s]= ");
	s_val=scanf("%d",&vel_l_ref);

	printf("back speed value [cm/s]= ");
	s_val=scanf("%d",&vel_b_ref);

	encoder_create();

	//vel_ctrl_set(vel_l_ref, vel_r_ref); 
	vel_ctrl_set((float)vel_l_ref, (float)vel_r_ref, (float)vel_b_ref); 
	vel_ctrl_create();

	thread_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


